﻿Imports System.IO

Public Class FormUnite
    Private Id As String
    Private PartNo As Integer

    Private Sub ButtonFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFolder.Click
        If FolderBrowserDialog.ShowDialog() = DialogResult.OK Then
            TextFolder.Text = FolderBrowserDialog.SelectedPath
        End If
    End Sub

    Private Sub ButtonAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAdd.Click
        If OpenFileDialog.ShowDialog() = DialogResult.OK Then
            Dim reader As StreamReader = New System.IO.StreamReader(OpenFileDialog.FileName)
            Dim header As String = reader.ReadToEnd()
            reader.Close()

            Dim attach As nMail.Attachment = New nMail.Attachment
            Dim no As Integer = attach.GetId(header)
            If ((no = 0) And (ListFile.Items.Count = 0)) Or (PartNo = no) Then
                If no = 1 Then
                    Id = attach.PartId
                End If
                If (no = 0) Or (Id = attach.PartId) Then
                    ListFile.Items.Add(OpenFileDialog.FileName)
                    PartNo += 1
                    ButtonSave.Enabled = True
                Else
                    MessageBox.Show("分割されたメールデータが一致しません", "vbmailnet", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            ElseIf (ListFile.Items.Count = 0) And (attach.GetHeaderField("Content-Type:", header).IndexOf("text/html") >= 0) Then
                ListFile.Items.Add(OpenFileDialog.FileName)
                ButtonSave.Enabled = True
            Else
                If no < 0 Then
                    MessageBox.Show("分割されたメールが存在しません", "vbmailnet", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Else
                    MessageBox.Show("分割されたメールデータの順番が正しくありません", "vbmailnet", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            End If
        End If
    End Sub

    Private Sub ButtonSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSave.Click
        If TextFolder.Text = "" Then
            Return
        End If
        If ListFile.Items.Count = 0 Then
            Return
        End If
        Dim attach As nMail.Attachment = New nMail.Attachment
        Try
            Dim no As Integer

            attach.Path = TextFolder.Text
            nMail.Options.EnableDecodeBody()
            For no = 0 To ListFile.Items.Count - 1
                Dim reader As StreamReader = New System.IO.StreamReader(CStr(ListFile.Items(no)))
                Dim header As String = reader.ReadToEnd()
                reader.Close()
                attach.Add(header)
            Next no
            attach.Save()
            ' 正常終了
            If attach.HtmlFile <> "" Then
                If MessageBox.Show(TextFolder.Text + " に添付ファイル " + attach.FileName + " を展開しました。" + ControlChars.CrLf + ControlChars.CrLf + "件名:" + attach.Subject + ControlChars.CrLf + "本文:" + ControlChars.CrLf + attach.Body + ControlChars.CrLf + "HTML ファイル " + attach.HtmlFile + " を開きますか？" + ControlChars.CrLf + "(ウィルス等がある場合があります。ご注意下さい)", "問い合わせ", MessageBoxButtons.YesNo) = DialogResult.Yes Then
                    Process.Start(attach.Path + "\\" + attach.HtmlFile)
                End If
            Else
                MessageBox.Show(TextFolder.Text + " に添付ファイル " + attach.FileName + " を保存しました。" + ControlChars.CrLf + ControlChars.CrLf + "件名:" + attach.Subject + ControlChars.CrLf + "本文:" + ControlChars.CrLf + attach.Body)
            End If
            Close()
        Catch nex As nMail.nMailException
            If nex.ErrorCode = nMail.Attachment.ErrorFileOpen Then
                MessageBox.Show("添付ファイルがオープンできません。")
            ElseIf nex.ErrorCode = nMail.Attachment.ErrorInvalidNo Then
                MessageBox.Show("分割されたメールの順番が正しくないか、該当しないファイルが入っています。")
            ElseIf nex.ErrorCode = nMail.Attachment.ErrorPartial Then
                MessageBox.Show("分割されたメールが全て揃っていません")
            End If
        Catch ex As Exception
            Debug.WriteLine(ex.Message)
        Finally
            attach.Dispose()
        End Try
    End Sub

    Private Sub ButtonCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCancel.Click

    End Sub

    Private Sub FormUnite_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        TextFolder.Text = Directory.GetCurrentDirectory
    End Sub
End Class